<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>ati.js - Documentation</title>

    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav>
    <li class="nav-link nav-home-link"><a href="index.html">Home</a></li><li class="nav-heading">Namespaces</li><li class="nav-heading"><span class="nav-item-type type-namespace">N</span><span class="nav-item-name"><a href="fox.html">fox</a></span></li><li class="nav-heading"><a href="global.html">Globals</a></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#advice">advice</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#decrypt">decrypt</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#discordDeconstruct">discordDeconstruct</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#discordSnowflake">discordSnowflake</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#e621">e621</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#e926">e926</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#encrypt">encrypt</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#fact">fact</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#furry">furry</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#hash">hash</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#hashVerify">hashVerify</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#keyGen">keyGen</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#keyGenAsymmetricKey">keyGenAsymmetricKey</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#keyring">keyring</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#keyringLoad">keyringLoad</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#owoify">owoify</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#parseURL">parseURL</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#sign">sign</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#snowflake">snowflake</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#snowflakeDeconstruct">snowflakeDeconstruct</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#twitterSnowflake">twitterSnowflake</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#uwuify">uwuify</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#verify">verify</a></span></li>
</nav>

<div id="main">
    
    <h1 class="page-title">ati.js</h1>
    

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>const { DiscordSnowflake, TwitterSnowflake, Snowflake } = require('@sapphire/snowflake');
const util = require('@sapphire/utilities');
const { Type } = require('@sapphire/type');
const { version } = require('./package.json');
const yiff = require('yiff');
const c = require('@aero/centra');
const owoifyx = require('owoifyx');
const { Uwuifier } = require('uwuifier');
const { Symmetric, SymmetricKey, Keyring, Asymmetric, AsymmetricSecretKey, Password } = require('dhole-crypto');

const ati = {};

const yiffConfig = {
	creator: 'ArtieFuzzz#8298',
	name: 'Ati',
	version: version,
};

/**
 * Generates a sort of discord snowflake.
 * @function
 * @name discordSnowflake
 */
ati.discordSnowflake = function discordSnowflake() {
	const DiscordFlake = new DiscordSnowflake();

	const Flake = DiscordFlake.generate();

	return (Flake);
};

/**
 * Can deconstruct a discord (actual) snowflake.
 * @function
 * @name discordDeconstruct
 */
ati.discordSnowflake.deconstruct = function discordDeconstruct(snowflake) {
	if (!snowflake) {
		throw new Error('No snowflake given');
	}
	else {
		// eslint-disable-next-line no-undef
		const flake = BigInt(snowflake);
		const deconstructedFlake = DiscordSnowflake.deconstruct(flake);

		return (deconstructedFlake);
	}
};

/**
 * Generates a custom Snowflake.
 * @function
 * @name snowflake
 * @param {object} Epoch - The epoch to use to create a snowflake.
 */
ati.snowflake = function snowflake(Epoch) {
	if (!Epoch) {
		throw new Error('No Epoch given');
	}
	const epoch = new Date(Epoch);

	const flake = new Snowflake(epoch);
	const snowflakey = flake.generate();

	return (snowflakey);
};

/**
 * Deconstruct a custom Snowflake.
 * @function
 * @name snowflakeDeconstruct
 * @param {number} snowflake - The snowflake to deconstruct
 * @param {object} Epoch - The epoch to use to create a snowflake.
 */
ati.snowflake.deconstruct = function snowflakeDeconstruct(snowflake, Epoch) {
	if (!snowflake) {
		throw new Error('No snowflake given');
	}
	else if (!Epoch) {
		throw new Error('No Epoch given');
	}
	else {
		// eslint-disable-next-line no-undef
		const flake = BigInt(snowflake);
		const epoch = new Date(Epoch);

		const snowflakey = new Snowflake(epoch).deconstruct(flake);
		return (snowflakey);
	}
};

/**
 * Generates a twitter Snowflake.
 * @function
 * @name twitterSnowflake
 */
ati.twitterSnowflake = function twitterSnowflake() {
	const snowflake = new TwitterSnowflake();

	const flake = snowflake.generate();
	return (flake);
};

/**
 * Deconstructs a twitter Snowflake.
 * @function
 * @name twitterSnowflake
 * @param {number} snowflake - Twitter snowflake to deconstruct
 */
ati.twitterSnowflake.deconstruct = function twitterSnowflakeDeconstruct(snowflake) {
	if (!snowflake) {
		throw new Error('No snowflake given');
	}
	else {
		// eslint-disable-next-line no-undef
		const flake = BigInt(snowflake);
		const deconstructedFlake = TwitterSnowflake.deconstruct(flake);

		return (deconstructedFlake);
	}
};

/**
 * Parses the given URL.
 * @function
 * @name parseURL
 * @param {string} URL - URL to parse
 */
ati.parseURL = function parseURL(url) {
	if (!url) {
		throw new Error('No url given');
	}
	else {
		const validURL = util.parseURL(url);

		if (validURL == null) {
			throw new Error('Not a valid URL');
		}
		else {
			return validURL;
		}
	}
};

// Not documented
ati.type = function type(typ) {
	if (!typ) {
		throw new Error('Nothing to see the type of.');
	}
	else {
		const typeo = new Type(typ);

		return typeo;
	}
};

/**
 * Get a random image from yiff.rest
 * @function
 * @name furry
 * @param {string} kind - Kind / Type (ie. sfw, nsfw, animals)
 * @param {string} endpoint - Endpoint (https://docs.yiff.rest/#list-categories)
 * @async
 */
ati.furry = async function(kind, endpoint) {
	if (!kind) {
		throw new TypeError('No kind specified (ie. animals [https://docs.yiff.rest/])');
	}
	else if (!endpoint) {
		throw new TypeError('No endpoint specified [https://docs.yiff.rest/]');
	}
	else {
		const data = await c(`https://yiff.rest/v2/${kind}/${endpoint}`).header({
			'User-Agent': `ati.js/${version} by ArtieFuzzz#8298`,
		}).send();
		const { images } = data.json;

		return images;
	}
};

/**
 * Find a random image with your provided tags on E621.net
 * @function
 * @name e621
 * @param {string} Tags - Tags used to search for an image
 * @async
 */
ati.e621 = async function atiE621(tags) {
	if (!tags) {
		throw new Error('No tags given');
	}
	else {
		const e6 = new yiff.e621(yiffConfig);

		const req = e6.request(tags);

		const data = await req;
		return data;
	}
};

/**
 * Find a random image with your provided tags on E926.net
 * @function
 * @name e926
 * @param {string} Tags - Tags used to search for an image
 * @async
 */
ati.e926 = async function atiE926(tags) {
	if (!tags) {
		throw new Error('No tags given');
	}
	else {
		const e9 = new yiff.e926(yiffConfig);

		const req = e9.request(tags);

		const data = await req;
		return data;
	}
};

/**
 * Gives you a random advice. (Very useful :v) )
 * @function
 * @name advice
 * @async
 */
ati.advice = async function advice() {
	const data = await c('https://api.adviceslip.com/advice').send();
	const { slip } = await data.json;

	return slip.advice;
};

/**
 * Get a random fact.
 * @function
 * @name fact
 * @async
 */
ati.fact = async function Getfact() {
	const data = await c('https://nekos.life/api/v2/fact').send();
	const { fact } = await data.json;

	return fact;
};

/**
 * OwOify a string.
 * @function
 * @name owoify
 * @param {string} str - String to owoify
 */
ati.owoify = function owoify(str) {
	if (!str) {
		throw new Error('No string given');
	}
	else {
		const owoifed = owoifyx(str);

		return owoifed;
	}
};

/**
 * UwUify a string.
 * @function
 * @name uwuify
 * @param {string} str - String to uwuify
 */
ati.uwuify = function uwuify(str) {
	const uwuifier = new Uwuifier();

	if (!str) {
		throw new Error('No string given');
	}
	else {
		return uwuifier.uwuifySentence(str);
	}
};

/**
 * fox is the start of the cryptography functions. WARNING ALL THE FOX FUNCTIONS ARE EXPERIMENTAL. EXPECT ERRORs
 * @function
 * @name fox
 * @namespace fox
 */
ati.fox = function fox() {
	throw new Error('Did you mean one of these?: fox.keyGen(), fox.keyGen.asymmetricKey(),  fox.encrypt(), fox.decrypt(), fox.keyring, fox.keyringLoad(), fox.sign(), fox.hash() or fox.hashVerify()');
};

/**
 * Generates a SymmetricKey.
 * @function
 * @name keyGen
 * @async
 * @example
 * // Returns a SymmetricKey
 * fox.keyGen().then(console.log);
 * @returns {SymmetricKey}
 */
ati.fox.keyGen = async function keyGen() {
	const symmetricKey = await SymmetricKey.generate();
	return symmetricKey;
};

/**
 * Generates a AsymmetricKey.
 * @function
 * @name keyGenAsymmetricKey
 * @async
 * @example
 * // Returns a AsymmetricKey
 * fox.keyGen.asymmetricKey().then(console.log);
 * @returns {AsymmetricKey}
 */
ati.fox.keyGen.asymmetricKey = async function asymmetricKeyGen() {
	const secret = await AsymmetricSecretKey.generate();

	return secret;
};

/**
 * Encrypts a string. !!WARNING THIS REQUIRES ati.fox.keyGen() TO WORK! also USE THE SAME KEY DO NOT COPY AND PASTE A KEY FROM THE CONSOLE / TERMINAL IT WILL NOT WORK
 * @function
 * @name encrypt
 * @async
 * @param {string} str - String to decrypt
 * @param {SymmetricKey} key - SymmetricKey used to decrypt the string
 * @example
 * fox.encrypt('hewwo!', key).then(console.log);
 * @returns {String}
 */
ati.fox.encrypt = async function foxencrypt(str, key) {
	if (!str) {
		throw new Error('No string given');
	}
	else if (!key) {
		throw new Error('No key given. Use ati.fox.keyGen() to make a key');
	}
	else {
		const encrypted = await Symmetric.encrypt(str, key);
		return encrypted;
	}
};

/**
 * Decrypts a string. !!WARNING THIS REQUIRES ati.fox.keyGen() TO WORK! also USE THE SAME KEY DO NOT COPY AND PASTE A KEY FROM THE CONSOLE / TERMINAL IT WILL NOT WORK
 * @function
 * @name decrypt
 * @async
 * @param {string} str - String to decrypt
 * @param {SymmetricKey} key - SymmetricKey used to decrypt the string
 * @example
 * fox.decrypt(encrypted, key).then(console.log);
 * @returns {String}
 */
ati.fox.decrypt = async function decrypt(str, key) {
	if (!key) {
		throw new Error('No key given. Use the same key you used to decrypt your message');
	}
	if (!str) {
		throw new TypeError('No string given to decrypt');
	}
	else {
		const decrypted = await Symmetric.decrypt(str, key);
		return decrypted.toString();
	}
};

/**
 * Turns a Key to a savable string.
 * @function
 * @name keyring
 * @async
 * @param {SymmetricKey|AsymmetricSecretKey|AsymmetricPublicKey} key - Key to turn into a savable string.
 * @example
 * fox.keyring(key).then(console.log);
 * @returns {String}
 */
ati.fox.keyring = async function keyring(key) {
	const ring = new Keyring();

	if (!key) {
		throw new TypeError('No key given');
	}
	else {
		const stringKey = await ring.save(key);
		return stringKey.toString();
	}
};

/**
 * Turns savable key into a useable Key.
 * @function
 * @name keyringLoad
 * @async
 * @param {SymmetricKey|AsymmetricSecretKey|AsymmetricPublicKey} key - The savable key to reconvert back to a SymmetricKey or AsymetricKey.
 * @example
 * fox.keyringLoad(key).then(console.log);
 * @returns {String}
 */
ati.fox.keyringLoad = async function keyringLoad(key) {
	const ring = new Keyring();

	if (!key) {
		throw new TypeError('No keyring string to turn into a SymmetricKey, AsymmetricSecretKey or AsymmetricPublicKey');
	}
	try {
		const key0 = await ring.load(key);

		return key0;
	}
	catch (err) {
		return console.log(err);
	}
};

/**
 * Sign a message. !!WARNING THIS FUNCTION DOES NOT PROPERLY WORK
 * @function
 * @name sign
 * @async
 * @param {String} msg - Message to sign.
 * @param {AsymmetricSecretKey} secret - SecretKey.
 * @example
 * fox.sign(msg, secret).then(console.log);
 * @returns {String}
 */
ati.fox.sign = async function sign(msg, secret) {
	if (!msg) {
		throw new TypeError('No msg to sign');
	}
	else {
		const signature = await Asymmetric.sign(msg, secret);

		return signature;
	}
};

/**
 * Sign a message.
 * @function
 * @name verify
 * @async
 * @param {String|Buffer} msg - Original message.
 * @param {AsymmetricPublicKey} publicKey - Public key to verify with.
 * @param {String|Buffer} signature - Signed message signature.
 * @example
 * fox.verify(msg, public, signature).then(console.log);
 * @returns {String}
 */
ati.fox.verify = async function verify(msg, publicKey, signature) {
	// The commented out code is just if I want to add a feature back
	/* if (!await Asymmetric.verify(msg, public, signature)) {
		console.log('Invalid signature. Unauthorized.');
	} */
	// else {
	const verified = await Asymmetric.verify(msg, publicKey, signature);

	return verified;
	// }
};

/**
 * Hashes a password.
 * @function
 * @name hash
 * @async
 * @param {String} password - Password to hash with.
 * @param {SymmetricKey} key - Key to hash the password.
 * @example
 * fox.hash(password, key).then(console.log);
 * @returns {String}
 */
ati.fox.hash = async function hash(password, key) {
	const PwHandler = new Password(key);

	if (!password) {
		throw new TypeError('No password to hash.');
	}
	else{
		const hashed = await PwHandler.hash(password);

		return hashed;
	}
};

/**
 * Verifies a hashed password.
 * @function
 * @name hashVerify
 * @async
 * @param {SymmetricKey} key - Key to hash the password.
 * @param {String} password - Password to hash with.
 * @param {String} hashed - Already hashed password to see if the current password matches the hash.
 * @example
 * fox.hash(key, password, hashed).then(console.log);
 * @returns {Boolean}
 */
ati.fox.hash.verify = async function hashVerify(key, password, hashed) {
	const PwHandler = new Password(key);

	if (!(key instanceof SymmetricKey)) {
		throw new TypeError('secret must be an instance of AsymmetricSecretKey');
	}
	else if (!hashed) {
		throw new TypeError('No hash to check password.');
	}
	else if (!password) {
		throw new TypeError('No password to check with hash');
	}
	else {
		const verified = await PwHandler.verify(password, hashed);

		return verified;
	}
};

module.exports = ati;</code></pre>
        </article>
    </section>




</div>

<br class="clear">

<footer>
    Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.6</a> on Wed Mar 24 2021 21:46:38 GMT+1100 (Australian Eastern Daylight Time) using the Minami theme.
</footer>

<script>prettyPrint();</script>
<script src="scripts/linenumber.js"></script>
</body>
</html>
